diff --git a/gcc/config/arm/arm.c b/gcc/config/arm/arm.c
index 0240cc7..6ee138e 100644
--- a/gcc/config/arm/arm.c
+++ b/gcc/config/arm/arm.c
@@ -629,7 +629,7 @@ static const struct attribute_spec arm_attribute_table[] =
 #undef TARGET_CLASS_LIKELY_SPILLED_P
 #define TARGET_CLASS_LIKELY_SPILLED_P arm_class_likely_spilled_p
 
-#undef TARGET_VECTORIZE_BUILTINS
+#undef GCC_OPTION (TARGET_VECTORIZE_BUILTINS)
 #define TARGET_VECTORIZE_BUILTINS
 
 #undef TARGET_VECTORIZE_BUILTIN_VECTORIZED_FUNCTION
@@ -669,7 +669,7 @@ static const struct attribute_spec arm_attribute_table[] =
 #define TARGET_ASAN_SHADOW_OFFSET arm_asan_shadow_offset
 
 #undef MAX_INSN_PER_IT_BLOCK
-#define MAX_INSN_PER_IT_BLOCK (arm_restrict_it ? 1 : 4)
+#define MAX_INSN_PER_IT_BLOCK (GCC_OPTION (arm_restrict_it) ? 1 : 4)
 
 #undef TARGET_CAN_USE_DOLOOP_P
 #define TARGET_CAN_USE_DOLOOP_P can_use_doloop_if_innermost
@@ -1894,7 +1894,7 @@ static void
 arm_init_libfuncs (void)
 {
   /* For Linux, we have access to kernel support for atomic operations.  */
-  if (arm_abi == ARM_ABI_AAPCS_LINUX)
+  if (GCC_OPTION (arm_abi) == ARM_ABI_AAPCS_LINUX)
     init_sync_libfuncs (2 * UNITS_PER_WORD);
 
   /* There are no special library functions unless we are using the
@@ -2001,18 +2001,18 @@ arm_init_libfuncs (void)
 
   /* Half-precision float operations.  The compiler handles all operations
      with NULL libfuncs by converting the SFmode.  */
-  switch (arm_fp16_format)
+  switch (GCC_OPTION (arm_fp16_format))
     {
     case ARM_FP16_FORMAT_IEEE:
     case ARM_FP16_FORMAT_ALTERNATIVE:
 
       /* Conversions.  */
       set_conv_libfunc (trunc_optab, HFmode, SFmode,
-			(arm_fp16_format == ARM_FP16_FORMAT_IEEE
+			(GCC_OPTION (arm_fp16_format) == ARM_FP16_FORMAT_IEEE
 			 ? "__gnu_f2h_ieee"
 			 : "__gnu_f2h_alternative"));
       set_conv_libfunc (sext_optab, SFmode, HFmode,
-			(arm_fp16_format == ARM_FP16_FORMAT_IEEE
+			(GCC_OPTION (arm_fp16_format) == ARM_FP16_FORMAT_IEEE
 			 ? "__gnu_h2f_ieee"
 			 : "__gnu_h2f_alternative"));
 
@@ -2267,16 +2267,16 @@ static void
 arm_option_override (void)
 {
   if (global_options_set.x_arm_arch_option)
-    arm_selected_arch = &all_architectures[arm_arch_option];
+    arm_selected_arch = &all_architectures[GCC_OPTION (arm_arch_option)];
 
   if (global_options_set.x_arm_cpu_option)
     {
-      arm_selected_cpu = &all_cores[(int) arm_cpu_option];
-      arm_selected_tune = &all_cores[(int) arm_cpu_option];
+      arm_selected_cpu = &all_cores[(int) GCC_OPTION (arm_cpu_option)];
+      arm_selected_tune = &all_cores[(int) GCC_OPTION (arm_cpu_option)];
     }
 
   if (global_options_set.x_arm_tune_option)
-    arm_selected_tune = &all_cores[(int) arm_tune_option];
+    arm_selected_tune = &all_cores[(int) GCC_OPTION (arm_tune_option)];
 
 #ifdef SUBTARGET_OVERRIDE_OPTIONS
   SUBTARGET_OVERRIDE_OPTIONS;
@@ -2414,25 +2414,25 @@ arm_option_override (void)
   if (TARGET_INTERWORK && !((insn_flags & FL_THUMB) || TARGET_BPABI))
     {
       warning (0, "target CPU does not support interworking" );
-      target_flags &= ~MASK_INTERWORK;
+      GCC_OPTION (target_flags) &= ~MASK_INTERWORK;
     }
 
   if (TARGET_THUMB && !(insn_flags & FL_THUMB))
     {
       warning (0, "target CPU does not support THUMB instructions");
-      target_flags &= ~MASK_THUMB;
+      GCC_OPTION (target_flags) &= ~MASK_THUMB;
     }
 
   if (TARGET_APCS_FRAME && TARGET_THUMB)
     {
       /* warning (0, "ignoring -mapcs-frame because -mthumb was used"); */
-      target_flags &= ~MASK_APCS_FRAME;
+      GCC_OPTION (target_flags) &= ~MASK_APCS_FRAME;
     }
 
   /* Callee super interworking implies thumb interworking.  Adding
      this to the flags here simplifies the logic elsewhere.  */
   if (TARGET_THUMB && TARGET_CALLEE_INTERWORKING)
-    target_flags |= MASK_INTERWORK;
+    GCC_OPTION (target_flags) |= MASK_INTERWORK;
 
   /* TARGET_BACKTRACE calls leaf_function_p, which causes a crash if done
      from here where no function is being compiled currently.  */
@@ -2445,13 +2445,13 @@ arm_option_override (void)
   if (TARGET_APCS_STACK && !TARGET_APCS_FRAME)
     {
       warning (0, "-mapcs-stack-check incompatible with -mno-apcs-frame");
-      target_flags |= MASK_APCS_FRAME;
+      GCC_OPTION (target_flags) |= MASK_APCS_FRAME;
     }
 
   if (TARGET_POKE_FUNCTION_NAME)
-    target_flags |= MASK_APCS_FRAME;
+    GCC_OPTION (target_flags) |= MASK_APCS_FRAME;
 
-  if (TARGET_APCS_REENT && flag_pic)
+  if (TARGET_APCS_REENT && GCC_OPTION (flag_pic))
     error ("-fpic and -mapcs-reent are incompatible");
 
   if (TARGET_APCS_REENT)
@@ -2460,7 +2460,7 @@ arm_option_override (void)
   /* If this target is normally configured to use APCS frames, warn if they
      are turned off and debugging is turned on.  */
   if (TARGET_ARM
-      && write_symbols != NO_DEBUG
+      && GCC_OPTION (write_symbols) != NO_DEBUG
       && !TARGET_APCS_FRAME
       && (TARGET_DEFAULT & MASK_APCS_FRAME))
     warning (0, "-g with -mno-apcs-frame may not give sensible debugging");
@@ -2500,11 +2500,11 @@ arm_option_override (void)
   arm_arch_arm_hwdiv = (insn_flags & FL_ARM_DIV) != 0;
   arm_tune_cortex_a9 = (arm_tune == cortexa9) != 0;
   arm_arch_crc = (insn_flags & FL_CRC32) != 0;
-  if (arm_restrict_it == 2)
-    arm_restrict_it = arm_arch8 && TARGET_THUMB2;
+  if (GCC_OPTION (arm_restrict_it) == 2)
+    GCC_OPTION (arm_restrict_it) = arm_arch8 && TARGET_THUMB2;
 
   if (!TARGET_THUMB2)
-    arm_restrict_it = 0;
+    GCC_OPTION (arm_restrict_it) = 0;
 
   /* If we are not using the default (ARM mode) section anchor offset
      ranges, then set the correct ranges now.  */
@@ -2536,7 +2536,7 @@ arm_option_override (void)
     arm_cpp_interwork = 1;
 
   if (arm_arch5)
-    target_flags &= ~MASK_INTERWORK;
+    GCC_OPTION (target_flags) &= ~MASK_INTERWORK;
 
   if (TARGET_IWMMXT && !ARM_DOUBLEWORD_ALIGN)
     error ("iwmmxt requires an AAPCS compatible ABI for proper operation");
@@ -2555,12 +2555,12 @@ arm_option_override (void)
       target_fpu_name = "vfp";
 #endif
 
-      ok = opt_enum_arg_to_value (OPT_mfpu_, target_fpu_name, &arm_fpu_index,
+      ok = opt_enum_arg_to_value (OPT_mfpu_, target_fpu_name, &GCC_OPTION (arm_fpu_index),
 				  CL_TARGET);
       gcc_assert (ok);
     }
 
-  arm_fpu_desc = &all_fpus[arm_fpu_index];
+  arm_fpu_desc = &all_fpus[GCC_OPTION (arm_fpu_index)];
 
   switch (arm_fpu_desc->model)
     {
@@ -2590,7 +2590,7 @@ arm_option_override (void)
     error ("iWMMXt unsupported under Thumb mode");
 
   /* __fp16 support currently assumes the core has ldrh.  */
-  if (!arm_arch4 && arm_fp16_format != ARM_FP16_FORMAT_NONE)
+  if (!arm_arch4 && GCC_OPTION (arm_fp16_format) != ARM_FP16_FORMAT_NONE)
     sorry ("__fp16 and no ldrh");
 
   /* If soft-float is specified then don't use FPU.  */
@@ -2599,9 +2599,9 @@ arm_option_override (void)
 
   if (TARGET_AAPCS_BASED)
     {
-      if (arm_abi == ARM_ABI_IWMMXT)
+      if (GCC_OPTION (arm_abi) == ARM_ABI_IWMMXT)
 	arm_pcs_default = ARM_PCS_AAPCS_IWMMXT;
-      else if (arm_float_abi == ARM_FLOAT_ABI_HARD
+      else if (GCC_OPTION (arm_float_abi) == ARM_FLOAT_ABI_HARD
 	       && TARGET_HARD_FLOAT
 	       && TARGET_VFP)
 	arm_pcs_default = ARM_PCS_AAPCS_VFP;
@@ -2610,10 +2610,10 @@ arm_option_override (void)
     }
   else
     {
-      if (arm_float_abi == ARM_FLOAT_ABI_HARD && TARGET_VFP)
+      if (GCC_OPTION (arm_float_abi) == ARM_FLOAT_ABI_HARD && TARGET_VFP)
 	sorry ("-mfloat-abi=hard and VFP");
 
-      if (arm_abi == ARM_ABI_APCS)
+      if (GCC_OPTION (arm_abi) == ARM_ABI_APCS)
 	arm_pcs_default = ARM_PCS_APCS;
       else
 	arm_pcs_default = ARM_PCS_ATPCS;
@@ -2622,15 +2622,15 @@ arm_option_override (void)
   /* For arm2/3 there is no need to do any scheduling if we are doing
      software floating-point.  */
   if (TARGET_SOFT_FLOAT && (tune_flags & FL_MODE32) == 0)
-    flag_schedule_insns = flag_schedule_insns_after_reload = 0;
+    GCC_OPTION (flag_schedule_insns) = GCC_OPTION (flag_schedule_insns_after_reload) = 0;
 
   /* Use the cp15 method if it is available.  */
-  if (target_thread_pointer == TP_AUTO)
+  if (GCC_OPTION (target_thread_pointer) == TP_AUTO)
     {
       if (arm_arch6k && !TARGET_THUMB1)
-	target_thread_pointer = TP_CP15;
+	GCC_OPTION (target_thread_pointer) = TP_CP15;
       else
-	target_thread_pointer = TP_SOFT;
+	GCC_OPTION (target_thread_pointer) = TP_SOFT;
     }
 
   if (TARGET_HARD_TP && TARGET_THUMB1)
@@ -2640,47 +2640,47 @@ arm_option_override (void)
   if (!global_options_set.x_arm_structure_size_boundary)
     {
       if (TARGET_AAPCS_BASED)
-	arm_structure_size_boundary = 8;
+	GCC_OPTION (arm_structure_size_boundary) = 8;
     }
   else
     {
-      if (arm_structure_size_boundary != 8
-	  && arm_structure_size_boundary != 32
-	  && !(ARM_DOUBLEWORD_ALIGN && arm_structure_size_boundary == 64))
+      if (GCC_OPTION (arm_structure_size_boundary) != 8
+	  && GCC_OPTION (arm_structure_size_boundary) != 32
+	  && !(ARM_DOUBLEWORD_ALIGN && GCC_OPTION (arm_structure_size_boundary) == 64))
 	{
 	  if (ARM_DOUBLEWORD_ALIGN)
 	    warning (0,
 		     "structure size boundary can only be set to 8, 32 or 64");
 	  else
 	    warning (0, "structure size boundary can only be set to 8 or 32");
-	  arm_structure_size_boundary
+	  GCC_OPTION (arm_structure_size_boundary)
 	    = (TARGET_AAPCS_BASED ? 8 : DEFAULT_STRUCTURE_SIZE_BOUNDARY);
 	}
     }
 
-  if (!TARGET_ARM && TARGET_VXWORKS_RTP && flag_pic)
+  if (!TARGET_ARM && TARGET_VXWORKS_RTP && GCC_OPTION (flag_pic))
     {
       error ("RTP PIC is incompatible with Thumb");
-      flag_pic = 0;
+      GCC_OPTION (flag_pic) = 0;
     }
 
   /* If stack checking is disabled, we can use r10 as the PIC register,
      which keeps r9 available.  The EABI specifies r9 as the PIC register.  */
-  if (flag_pic && TARGET_SINGLE_PIC_BASE)
+  if (GCC_OPTION (flag_pic) && GCC_OPTION (TARGET_SINGLE_PIC_BASE))
     {
       if (TARGET_VXWORKS_RTP)
 	warning (0, "RTP PIC is incompatible with -msingle-pic-base");
       arm_pic_register = (TARGET_APCS_STACK || TARGET_AAPCS_BASED) ? 9 : 10;
     }
 
-  if (flag_pic && TARGET_VXWORKS_RTP)
+  if (GCC_OPTION (flag_pic) && TARGET_VXWORKS_RTP)
     arm_pic_register = 9;
 
-  if (arm_pic_register_string != NULL)
+  if (GCC_OPTION (arm_pic_register_string) != NULL)
     {
-      int pic_register = decode_reg_name (arm_pic_register_string);
+      int pic_register = decode_reg_name (GCC_OPTION (arm_pic_register_string));
 
-      if (!flag_pic)
+      if (!GCC_OPTION (flag_pic))
 	warning (0, "-mpic-register= is useless without -fpic");
 
       /* Prevent the user from choosing an obviously stupid PIC register.  */
@@ -2690,22 +2690,22 @@ arm_option_override (void)
 	       || pic_register >= PC_REGNUM
 	       || (TARGET_VXWORKS_RTP
 		   && (unsigned int) pic_register != arm_pic_register))
-	error ("unable to use '%s' for PIC register", arm_pic_register_string);
+	error ("unable to use '%s' for PIC register", GCC_OPTION (arm_pic_register_string));
       else
 	arm_pic_register = pic_register;
     }
 
   if (TARGET_VXWORKS_RTP
       && !global_options_set.x_arm_pic_data_is_text_relative)
-    arm_pic_data_is_text_relative = 0;
+    GCC_OPTION (arm_pic_data_is_text_relative) = 0;
 
   /* Enable -mfix-cortex-m3-ldrd by default for Cortex-M3 cores.  */
-  if (fix_cm3_ldrd == 2)
+  if (GCC_OPTION (fix_cm3_ldrd) == 2)
     {
       if (arm_selected_cpu->core == cortexm3)
-	fix_cm3_ldrd = 1;
+	GCC_OPTION (fix_cm3_ldrd) = 1;
       else
-	fix_cm3_ldrd = 0;
+	GCC_OPTION (fix_cm3_ldrd) = 0;
     }
 
   /* Enable -munaligned-access by default for
@@ -2717,27 +2717,27 @@ arm_option_override (void)
      - all pre-ARMv6 architecture-based processors
      - ARMv6-M architecture-based processors.  */
 
-  if (unaligned_access == 2)
+  if (GCC_OPTION (unaligned_access) == 2)
     {
       if (arm_arch6 && (arm_arch_notm || arm_arch7))
-	unaligned_access = 1;
+	GCC_OPTION (unaligned_access) = 1;
       else
-	unaligned_access = 0;
+	GCC_OPTION (unaligned_access) = 0;
     }
-  else if (unaligned_access == 1
+  else if (GCC_OPTION (unaligned_access) == 1
 	   && !(arm_arch6 && (arm_arch_notm || arm_arch7)))
     {
       warning (0, "target CPU does not support unaligned accesses");
-      unaligned_access = 0;
+      GCC_OPTION (unaligned_access) = 0;
     }
 
-  if (TARGET_THUMB1 && flag_schedule_insns)
+  if (TARGET_THUMB1 && GCC_OPTION (flag_schedule_insns))
     {
       /* Don't warn since it's on by default in -O2.  */
-      flag_schedule_insns = 0;
+      GCC_OPTION (flag_schedule_insns) = 0;
     }
 
-  if (optimize_size)
+  if (GCC_OPTION (optimize_size))
     {
       /* If optimizing for size, bump the number of instructions that we
          are prepared to conditionally execute (even on a StrongARM).  */
@@ -2748,15 +2748,15 @@ arm_option_override (void)
 
   /* Hot/Cold partitioning is not currently supported, since we can't
      handle literal pool placement in that case.  */
-  if (flag_reorder_blocks_and_partition)
+  if (GCC_OPTION (flag_reorder_blocks_and_partition))
     {
       inform (input_location,
 	      "-freorder-blocks-and-partition not supported on this architecture");
-      flag_reorder_blocks_and_partition = 0;
-      flag_reorder_blocks = 1;
+      GCC_OPTION (flag_reorder_blocks_and_partition) = 0;
+      GCC_OPTION (flag_reorder_blocks) = 1;
     }
 
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     /* Hoisting PIC address calculations more aggressively provides a small,
        but measurable, size reduction for PIC code.  Therefore, we decrease
        the bar for unrestricted expression hoisting to the cost of PIC address
@@ -2766,17 +2766,17 @@ arm_option_override (void)
 			   global_options_set.x_param_values);
 
   /* ARM EABI defaults to strict volatile bitfields.  */
-  if (TARGET_AAPCS_BASED && flag_strict_volatile_bitfields < 0
+  if (TARGET_AAPCS_BASED && GCC_OPTION (flag_strict_volatile_bitfields) < 0
       && abi_version_at_least(2))
-    flag_strict_volatile_bitfields = 1;
+    GCC_OPTION (flag_strict_volatile_bitfields) = 1;
 
   /* Enable sw prefetching at -O3 for CPUS that have prefetch, and we have deemed
      it beneficial (signified by setting num_prefetch_slots to 1 or more.)  */
-  if (flag_prefetch_loop_arrays < 0
+  if (GCC_OPTION (flag_prefetch_loop_arrays) < 0
       && HAVE_prefetch
-      && optimize >= 3
+      && GCC_OPTION (optimize) >= 3
       && current_tune->num_prefetch_slots > 0)
-    flag_prefetch_loop_arrays = 1;
+    GCC_OPTION (flag_prefetch_loop_arrays) = 1;
 
   /* Set up parameters to be used in prefetching algorithm.  Do not override the
      defaults unless we are tuning for a core we have researched values for.  */
@@ -2799,7 +2799,7 @@ arm_option_override (void)
   /* Use Neon to perform 64-bits operations rather than core
      registers.  */
   prefer_neon_for_64bits = current_tune->prefer_neon_for_64bits;
-  if (use_neon_for_64bits == 1)
+  if (GCC_OPTION (use_neon_for_64bits) == 1)
      prefer_neon_for_64bits = true;
 
   /* Use the alternative scheduling-pressure algorithm by default.  */
@@ -2810,15 +2810,15 @@ arm_option_override (void)
   /* Disable shrink-wrap when optimizing function for size, since it tends to
      generate additional returns.  */
   if (optimize_function_for_size_p (cfun) && TARGET_THUMB2)
-    flag_shrink_wrap = false;
+    GCC_OPTION (flag_shrink_wrap) = false;
   /* TBD: Dwarf info for apcs frame is not handled yet.  */
   if (TARGET_APCS_FRAME)
-    flag_shrink_wrap = false;
+    GCC_OPTION (flag_shrink_wrap) = false;
 
   /* We only support -mslow-flash-data on armv7-m targets.  */
   if (target_slow_flash_data
       && ((!(arm_arch7 && !arm_arch_notm) && !arm_arch7em)
-	  || (TARGET_THUMB1 || flag_pic || TARGET_NEON)))
+	  || (TARGET_THUMB1 || GCC_OPTION (flag_pic) || TARGET_NEON)))
     error ("-mslow-flash-data only supports non-pic code on armv7-m targets");
 
   /* Currently, for slow flash data, we just disable literal pools.  */
@@ -2910,10 +2910,10 @@ arm_compute_func_type (void)
      never return, and many memory cycles can be saved by not storing
      register values that will never be needed again.  This optimization
      was added to speed up context switching in a kernel application.  */
-  if (optimize > 0
+  if (GCC_OPTION (optimize) > 0
       && (TREE_NOTHROW (current_function_decl)
-          || !(flag_unwind_tables
-               || (flag_exceptions
+          || !(GCC_OPTION (flag_unwind_tables)
+               || (GCC_OPTION (flag_exceptions)
 		   && arm_except_unwind_info (&global_options) != UI_SJLJ)))
       && TREE_THIS_VOLATILE (current_function_decl))
     type |= ARM_FT_VOLATILE;
@@ -3148,7 +3148,7 @@ use_return_insn (int iscond, rtx sibling)
       if (saved_int_regs != 0 && saved_int_regs != (1 << LR_REGNUM))
 	return 0;
 
-      if (flag_pic
+      if (GCC_OPTION (flag_pic)
 	  && arm_pic_register != INVALID_REGNUM
 	  && df_regs_ever_live_p (PIC_OFFSET_TABLE_REGNUM))
 	return 0;
@@ -4708,7 +4708,7 @@ arm_return_in_memory (const_tree type, const_tree fntype)
     /* All simple types are returned in registers.  */
     return false;
 
-  if (arm_abi != ARM_ABI_APCS)
+  if (GCC_OPTION (arm_abi) != ARM_ABI_APCS)
     {
       /* ATPCS and later return aggregate types in memory only if they are
 	 larger than a word (or are variable size).  */
@@ -4878,7 +4878,7 @@ arm_get_pcs_model (const_tree type, const_tree decl)
 	return ARM_PCS_AAPCS;
       else if (user_convention)
 	return user_pcs;
-      else if (decl && flag_unit_at_a_time)
+      else if (decl && GCC_OPTION (flag_unit_at_a_time))
 	{
 	  /* Local functions never leak outside this compilation unit,
 	     so we are free to use whatever conventions are
@@ -5614,7 +5614,7 @@ arm_init_cumulative_args (CUMULATIVE_ARGS *pcum, tree fntype,
 static bool
 arm_lra_p (void)
 {
-  return arm_lra_flag;
+  return GCC_OPTION (arm_lra_flag);
 }
 
 /* Return true if mode/type need doubleword alignment.  */
@@ -6012,7 +6012,7 @@ arm_function_in_section_p (tree decl, section *section)
   if (!DECL_SECTION_NAME (decl))
     {
       /* Make sure that we will not create a unique section for DECL.  */
-      if (flag_function_sections || DECL_ONE_ONLY (decl))
+      if (GCC_OPTION (flag_function_sections) || DECL_ONE_ONLY (decl))
 	return false;
     }
 
@@ -6039,7 +6039,7 @@ arm_is_long_call_p (tree decl)
   tree attrs;
 
   if (!decl)
-    return TARGET_LONG_CALLS;
+    return GCC_OPTION (TARGET_LONG_CALLS);
 
   attrs = TYPE_ATTRIBUTES (TREE_TYPE (decl));
   if (lookup_attribute ("short_call", attrs))
@@ -6047,7 +6047,7 @@ arm_is_long_call_p (tree decl)
 
   /* For "f", be conservative, and only cater for cases in which the
      whole of the current function is placed in the same section.  */
-  if (!flag_reorder_blocks_and_partition
+  if (!GCC_OPTION (flag_reorder_blocks_and_partition)
       && TREE_CODE (decl) == FUNCTION_DECL
       && arm_function_in_section_p (decl, current_function_section ()))
     return false;
@@ -6055,7 +6055,7 @@ arm_is_long_call_p (tree decl)
   if (lookup_attribute ("long_call", attrs))
     return true;
 
-  return TARGET_LONG_CALLS;
+  return GCC_OPTION (TARGET_LONG_CALLS);
 }
 
 /* Return nonzero if it is ok to make a tail-call to DECL.  */
@@ -6073,7 +6073,7 @@ arm_function_ok_for_sibcall (tree decl, tree exp)
 
   /* The PIC register is live on entry to VxWorks PLT entries, so we
      must make the call before restoring the PIC register.  */
-  if (TARGET_VXWORKS_RTP && flag_pic && !targetm.binds_local_p (decl))
+  if (TARGET_VXWORKS_RTP && GCC_OPTION (flag_pic) && !targetm.binds_local_p (decl))
     return false;
 
   /* Cannot tail-call to long calls, since these are out of range of
@@ -6116,7 +6116,7 @@ arm_function_ok_for_sibcall (tree decl, tree exp)
      references should become a NOP.  Don't convert such calls into
      sibling calls.  */
   if (TARGET_AAPCS_BASED
-      && arm_abi == ARM_ABI_AAPCS
+      && GCC_OPTION (arm_abi) == ARM_ABI_AAPCS
       && decl
       && DECL_WEAK (decl))
     return false;
@@ -6232,7 +6232,7 @@ legitimize_pic_address (rtx orig, enum machine_mode mode, rtx reg)
 	   || (GET_CODE (orig) == SYMBOL_REF &&
 	       SYMBOL_REF_LOCAL_P (orig)))
 	  && NEED_GOT_RELOC
-	  && arm_pic_data_is_text_relative)
+	  && GCC_OPTION (arm_pic_data_is_text_relative))
 	insn = arm_pic_static_addr (orig, reg);
       else
 	{
@@ -6397,10 +6397,10 @@ arm_load_pic_register (unsigned long saved_regs ATTRIBUTE_UNUSED)
 {
   rtx l1, labelno, pic_tmp, pic_rtx, pic_reg;
 
-  if (crtl->uses_pic_offset_table == 0 || TARGET_SINGLE_PIC_BASE)
+  if (crtl->uses_pic_offset_table == 0 || GCC_OPTION (TARGET_SINGLE_PIC_BASE))
     return;
 
-  gcc_assert (flag_pic);
+  gcc_assert (GCC_OPTION (flag_pic));
 
   pic_reg = cfun->machine->pic_reg;
   if (TARGET_VXWORKS_RTP)
@@ -6471,7 +6471,7 @@ arm_pic_static_addr (rtx orig, rtx reg)
 {
   rtx l1, labelno, offset_rtx, insn;
 
-  gcc_assert (flag_pic);
+  gcc_assert (GCC_OPTION (flag_pic));
 
   /* We use an UNSPEC rather than a LABEL_REF because this label
      never appears in the code stream.  */
@@ -6611,7 +6611,7 @@ arm_legitimate_address_outer_p (enum machine_mode mode, rtx x, RTX_CODE outer,
   else if (GET_MODE_CLASS (mode) != MODE_FLOAT
 	   && code == SYMBOL_REF
 	   && CONSTANT_POOL_ADDRESS_P (x)
-	   && ! (flag_pic
+	   && ! (GCC_OPTION (flag_pic)
 		 && symbol_mentioned_p (get_pool_constant (x))
 		 && ! pcrel_constant_p (get_pool_constant (x))))
     return 1;
@@ -6705,7 +6705,7 @@ thumb2_legitimate_address_p (enum machine_mode mode, rtx x, int strict_p)
   else if (GET_MODE_CLASS (mode) != MODE_FLOAT
 	   && code == SYMBOL_REF
 	   && CONSTANT_POOL_ADDRESS_P (x)
-	   && ! (flag_pic
+	   && ! (GCC_OPTION (flag_pic)
 		 && symbol_mentioned_p (get_pool_constant (x))
 		 && ! pcrel_constant_p (get_pool_constant (x))))
     return 1;
@@ -6998,7 +6998,7 @@ thumb1_legitimate_address_p (enum machine_mode mode, rtx x, int strict_p)
   /* This is PC relative data before arm_reorg runs.  */
   else if (GET_MODE_SIZE (mode) >= 4 && CONSTANT_P (x)
 	   && GET_CODE (x) == SYMBOL_REF
-           && CONSTANT_POOL_ADDRESS_P (x) && !flag_pic)
+           && CONSTANT_POOL_ADDRESS_P (x) && !GCC_OPTION (flag_pic))
     return 1;
 
   /* This is PC relative data after arm_reorg runs.  */
@@ -7066,7 +7066,7 @@ thumb1_legitimate_address_p (enum machine_mode mode, rtx x, int strict_p)
 	   && GET_MODE_SIZE (mode) == 4
 	   && GET_CODE (x) == SYMBOL_REF
 	   && CONSTANT_POOL_ADDRESS_P (x)
-	   && ! (flag_pic
+	   && ! (GCC_OPTION (flag_pic)
 		 && symbol_mentioned_p (get_pool_constant (x))
 		 && ! pcrel_constant_p (get_pool_constant (x))))
     return 1;
@@ -7438,7 +7438,7 @@ arm_legitimize_address (rtx x, rtx orig_x, enum machine_mode mode)
      with absolute addresses which often allows for the base register to
      be factorized for multiple adjacent memory references, and it might
      even allows for the mini pool to be avoided entirely. */
-  else if (CONST_INT_P (x) && optimize > 0)
+  else if (CONST_INT_P (x) && GCC_OPTION (optimize) > 0)
     {
       unsigned int bits;
       HOST_WIDE_INT mask, base, index;
@@ -7462,7 +7462,7 @@ arm_legitimize_address (rtx x, rtx orig_x, enum machine_mode mode)
       x = plus_constant (Pmode, base_reg, index);
     }
 
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     {
       /* We need to find and carefully transform any SYMBOL and LABEL
 	 references; so go back to the original address expression.  */
@@ -7493,7 +7493,7 @@ thumb_legitimize_address (rtx x, rtx orig_x, enum machine_mode mode)
       /* Try and fold the offset into a biasing of the base register and
 	 then offsetting that.  Don't do this when optimizing for space
 	 since it can cause too many CSEs.  */
-      if (optimize_size && offset >= 0
+      if (GCC_OPTION (optimize_size) && offset >= 0
 	  && offset < 256 + 31 * GET_MODE_SIZE (mode))
 	{
 	  HOST_WIDE_INT delta;
@@ -7530,7 +7530,7 @@ thumb_legitimize_address (rtx x, rtx orig_x, enum machine_mode mode)
       x = gen_rtx_PLUS (SImode, xop0, XEXP (x, 1));
     }
 
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     {
       /* We need to find and carefully transform any SYMBOL and LABEL
 	 references; so go back to the original address expression.  */
@@ -7820,7 +7820,7 @@ arm_legitimate_constant_p_1 (enum machine_mode mode, rtx x)
   if (TARGET_NEON && VALID_NEON_STRUCT_MODE (mode))
     return false;
 
-  return flag_pic || !label_mentioned_p (x);
+  return GCC_OPTION (flag_pic) || !label_mentioned_p (x);
 }
 
 static bool
@@ -7829,7 +7829,7 @@ thumb_legitimate_constant_p (enum machine_mode mode ATTRIBUTE_UNUSED, rtx x)
   return (CONST_INT_P (x)
 	  || CONST_DOUBLE_P (x)
 	  || CONSTANT_ADDRESS_P (x)
-	  || flag_pic);
+	  || GCC_OPTION (flag_pic));
 }
 
 static bool
@@ -8758,7 +8758,7 @@ arm_size_rtx_costs (rtx x, enum rtx_code code, enum rtx_code outer_code,
 	 a single register, otherwise it costs one insn per word.  */
       if (REG_P (XEXP (x, 0)))
 	*total = COSTS_N_INSNS (1);
-      else if (flag_pic
+      else if (GCC_OPTION (flag_pic)
 	       && GET_CODE (XEXP (x, 0)) == PLUS
 	       && will_be_in_index_register (XEXP (XEXP (x, 0), 1)))
 	/* This will be split into two instructions.
@@ -9161,7 +9161,7 @@ arm_new_rtx_costs (rtx x, enum rtx_code code, enum rtx_code outer_code,
 	 a single register, otherwise it costs one insn per word.  */
       if (REG_P (XEXP (x, 0)))
 	*cost = COSTS_N_INSNS (1);
-      else if (flag_pic
+      else if (GCC_OPTION (flag_pic)
 	       && GET_CODE (XEXP (x, 0)) == PLUS
 	       && will_be_in_index_register (XEXP (XEXP (x, 0), 1)))
 	/* This will be split into two instructions.
@@ -10435,7 +10435,7 @@ arm_new_rtx_costs (rtx x, enum rtx_code code, enum rtx_code outer_code,
     case SYMBOL_REF:
       if (speed_p)
 	{
-	  if (arm_arch_thumb2 && !flag_pic)
+	  if (arm_arch_thumb2 && !GCC_OPTION (flag_pic))
 	    *cost = COSTS_N_INSNS (2);
 	  else
 	    *cost = COSTS_N_INSNS (1) + extra_cost->ldst.load;
@@ -10443,7 +10443,7 @@ arm_new_rtx_costs (rtx x, enum rtx_code code, enum rtx_code outer_code,
       else
 	*cost = COSTS_N_INSNS (2);
 
-      if (flag_pic)
+      if (GCC_OPTION (flag_pic))
 	{
 	  *cost += COSTS_N_INSNS (1);
 	  if (speed_p)
@@ -11355,7 +11355,7 @@ arm_add_stmt_cost (void *data, int count, enum vect_cost_for_stmt kind,
   unsigned *cost = (unsigned *) data;
   unsigned retval = 0;
 
-  if (flag_vect_cost_model)
+  if (GCC_OPTION (flag_vect_cost_model))
     {
       tree vectype = stmt_info ? stmt_vectype (stmt_info) : NULL_TREE;
       int stmt_cost = arm_builtin_vectorization_cost (kind, vectype, misalign);
@@ -11617,7 +11617,7 @@ arm_default_branch_cost (bool speed_p, bool predictable_p ATTRIBUTE_UNUSED)
   if (TARGET_32BIT)
     return (TARGET_THUMB2 && !speed_p) ? 1 : 4;
   else
-    return (optimize > 0) ? 2 : 0;
+    return (GCC_OPTION (optimize) > 0) ? 2 : 0;
 }
 
 static int
@@ -12897,7 +12897,7 @@ adjacent_mem_locations (rtx a, rtx b)
 	  /* If the target has load delay slots, then there's no benefit
 	     to using an ldm instruction unless the offset is zero and
 	     we are optimizing for size.  */
-	  return (optimize_size && (REGNO (reg0) == REGNO (reg1))
+	  return (GCC_OPTION (optimize_size) && (REGNO (reg0) == REGNO (reg1))
 		  && (val0 == 0 || val1 == 0 || val0 == 4 || val1 == 4)
 		  && (val_diff == 4 || val_diff == -4));
 	}
@@ -13151,7 +13151,7 @@ multiple_operation_profitable_p (bool is_store ATTRIBUTE_UNUSED,
 
      As a compromise, we use ldr for counts of 1 or 2 regs, and ldm
      for counts of 3 or 4 regs.  */
-  if (nops <= 2 && arm_tune_xscale && !optimize_size)
+  if (nops <= 2 && arm_tune_xscale && !GCC_OPTION (optimize_size))
     return false;
   return true;
 }
@@ -14198,7 +14198,7 @@ arm_movmemqi_unaligned (rtx *operands)
 {
   HOST_WIDE_INT length = INTVAL (operands[2]);
   
-  if (optimize_size)
+  if (GCC_OPTION (optimize_size))
     {
       bool src_aligned = MEM_ALIGN (operands[1]) >= BITS_PER_WORD;
       bool dst_aligned = MEM_ALIGN (operands[0]) >= BITS_PER_WORD;
@@ -14245,7 +14245,7 @@ arm_gen_movmemqi (rtx *operands)
       || INTVAL (operands[2]) > 64)
     return 0;
 
-  if (unaligned_access && (INTVAL (operands[3]) & 3) != 0)
+  if (GCC_OPTION (unaligned_access) && (INTVAL (operands[3]) & 3) != 0)
     return arm_movmemqi_unaligned (operands);
 
   if (INTVAL (operands[3]) & 3)
@@ -14414,7 +14414,7 @@ gen_movmem_ldrd_strd (rtx *operands)
   /* Maximum alignment we can assume for both src and dst buffers.  */
   align = INTVAL (operands[3]);
 
-  if ((!unaligned_access) && (len >= 4) && ((align & 3) != 0))
+  if ((!GCC_OPTION (unaligned_access)) && (len >= 4) && ((align & 3) != 0))
     return false;
 
   /* Place src and dst addresses in registers
@@ -14431,7 +14431,7 @@ gen_movmem_ldrd_strd (rtx *operands)
   base = copy_to_mode_reg (SImode, XEXP (src, 0));
   src = adjust_automodify_address (src, VOIDmode, base, 0);
 
-  if (!unaligned_access && !(src_aligned && dst_aligned))
+  if (!GCC_OPTION (unaligned_access) && !(src_aligned && dst_aligned))
     return false;
 
   if (src_volatile || dst_volatile)
@@ -15300,7 +15300,7 @@ operands_ok_ldrd_strd (rtx rt, rtx rt2, rtx rn, HOST_WIDE_INT offset,
           || (!load && (n == PC_REGNUM))
           || (load && (t == t2))
           /* Triggers Cortex-M3 LDRD errata.  */
-          || (!wback && load && fix_cm3_ldrd && (n == t))))
+          || (!wback && load && GCC_OPTION (fix_cm3_ldrd) && (n == t))))
     return false;
 
   if ((TARGET_ARM)
@@ -16535,7 +16535,7 @@ arm_max_const_double_inline_cost ()
   if (arm_disable_literal_pool)
     return 99;
 
-  return ((optimize_size || arm_ld_sched) ? 3 : 4);
+  return ((GCC_OPTION (optimize_size) || arm_ld_sched) ? 3 : 4);
 }
 
 /* Return the cost of synthesizing a 64-bit constant VAL inline.
@@ -16576,7 +16576,7 @@ arm_const_double_by_parts (rtx val)
   enum machine_mode mode = GET_MODE (val);
   rtx part;
 
-  if (optimize_size || arm_ld_sched)
+  if (GCC_OPTION (optimize_size) || arm_ld_sched)
     return true;
 
   if (mode == VOIDmode)
@@ -16867,7 +16867,7 @@ thumb2_reorg (void)
 			 known implementations.  We do not even want to use
 			 MULS in cold code, if optimizing for speed, so we
 			 test the global flag here.  */
-		      if (!optimize_size)
+		      if (!GCC_OPTION (optimize_size))
 			break;
 		      /* else fall through.  */
 		    case AND:
@@ -16982,7 +16982,7 @@ arm_reorg (void)
      Otherwise, the pool placement code below may compute incorrect
      insn lengths.  Note that when optimizing, all insns have already
      been split at this point.  */
-  if (!optimize)
+  if (!GCC_OPTION (optimize))
     split_all_insns_noflow ();
 
   minipool_fix_head = minipool_fix_tail = NULL;
@@ -17374,7 +17374,7 @@ arm_emit_call_insn (rtx pat, rtx addr)
      If the call might use such an entry, add a use of the PIC register
      to the instruction's CALL_INSN_FUNCTION_USAGE.  */
   if (TARGET_VXWORKS_RTP
-      && flag_pic
+      && GCC_OPTION (flag_pic)
       && GET_CODE (addr) == SYMBOL_REF
       && (SYMBOL_REF_DECL (addr)
 	  ? !targetm.binds_local_p (SYMBOL_REF_DECL (addr))
@@ -17531,7 +17531,7 @@ output_move_double (rtx *operands, bool emit, int *count)
 	  if (emit)
 	    {
 	      if (TARGET_LDRD
-		  && !(fix_cm3_ldrd && reg0 == REGNO(XEXP (operands[1], 0))))
+		  && !(GCC_OPTION (fix_cm3_ldrd) && reg0 == REGNO(XEXP (operands[1], 0))))
 		output_asm_insn ("ldr%(d%)\t%0, [%m1]", operands);
 	      else
 		output_asm_insn ("ldm%(ia%)\t%m1, %M0", operands);
@@ -17723,7 +17723,7 @@ output_move_double (rtx *operands, bool emit, int *count)
 		      /* If both registers conflict, it will usually
 			 have been fixed by a splitter.  */
 		      if (reg_overlap_mentioned_p (operands[0], otherops[2])
-			  || (fix_cm3_ldrd && reg0 == REGNO (otherops[1])))
+			  || (GCC_OPTION (fix_cm3_ldrd) && reg0 == REGNO (otherops[1])))
 			{
 			  if (emit)
 			    {
